
%% ==== random field modified
clear all;

% first run  (make up input)
mean_map=zeros(40,60);
reading=[30.5 34];
position=[20 30; 1 40];
parameters.neighbour_sigma=1;
parameters.sensor_sigma=0.1;
parameters.time_sigma=0.1;
parameters.error_tolerance=0.00001;
variance_map=zeros(40*60,40*60);
occupancy_map=ones(40,60);

[mean_map, variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);

K=mat2gray(mean_map);
imshow(K, 'InitialMagnification', 800);

%%
reading=[33 30];
position=[40 1; 1 60];


[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);
K=mat2gray(mean_map);
imshow(K, 'InitialMagnification', 800);

%% How the reading and position changes affect the reading
clear all;

mean_map=zeros(40,60);
parameters.neighbour_sigma=1;
parameters.sensor_sigma=0.1;
parameters.time_sigma=sqrt(0.02);
parameters.error_tolerance=0.00001;
variance_map=zeros(40*60,40*60);
occupancy_map=ones(40,60);
reading=[33 30];
position=[40 1; 1 60];
[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);


n=20;
var=struct([]);
mean=struct([]);
for i=1:n
    mean_temp=mean_map;
    variance_temp=variance_map;
    
    % no change in position and reading
    reading=[33 30];
    position=[40 1; 1 60];
    %Result: After the second update, there is small change in mean map and
    %small change in variance map
     
    % only change the reading
    %reading=[33+i 30-i];
    %position=[40 10; 10 60];
    %Result: diagnal increase because the time uncertainty, other decrease
    %in the covariance are very small smaller than 0.000001
    
    % see if the similar result with close position reading
    %reading=[33+10*i 30-10*i];
    %position=[10 20; 11 21];
    %Result: This change affect less comparing with last one on mean map,
    %however it is same effect on variance map as last one. 
    
    %Change the position
    %reading=[33 30];
    %position=[40-i 10; 11 21];
    %Result: mean change samller and smaller as position move, variance matrix 
    % changed smaller and smaller but change is big.
    
    %Change the position and reading
    %reading=[33+i 30-i];
    %position=[10+2*i 20+2*i; 11-i 21-i];
    %Result: variance change in the same degree as last one, mean change
    %bigger
    
    %Simulate three point, two static points and one change point
    %reading=[33 30 30+i];
    %position=[40 10; 10 60; 10+2*i 20+2*i];
    %Result: both change as expected.
    
    [mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);
    a=(variance_map-variance_temp);
    [pr,pc]=find(a>0.000001);
    [nr,nc]=find(a<-0.0000001);
    var(i).matrix=a;
    var(i).positive=[pr pc];
    var(i).negative=[nr nc];
    var(i).error=sum(a(:).^2);
    
    b=(mean_map-mean_temp);
    [pr,pc]=find(a>0.000001);
    [nr,nc]=find(a<-0.000001);
    mean(i).matrix=b;
    mean(i).positive=[pr pc];
    mean(i).negative=[nr nc];
    mean(i).error=sum(b(:).^2);
end

%% test file 

clear all;

mean_map=zeros(10,10);
parameters.neighbour_sigma=1;
parameters.sensor_sigma=0.1;
parameters.time_sigma=0.1;
parameters.error_tolerance=0.00001;
variance_map=zeros(10*10,10*10);
occupancy_map=ones(10,10);
parameters.occupancyThreshold=2;

dlmwrite('mean0.csv',mean_map,'precision',9)
dlmwrite('variance0.csv',variance_map,'precision',9)

reading=33;
position=[5 1];

[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);

%reading=[33 30];
%position=[5 1; 2 8];
%%

reading= 30;
position=[2 8];

[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);

%%


dlmwrite('mean1.csv',mean_map,'precision',9)
dlmwrite('variance1.csv',variance_map,'precision',9)

[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);

dlmwrite('mean2.csv',mean_map,'precision',9)
dlmwrite('variance2.csv',variance_map,'precision',9)

%%   test occupancy 
clear all;
mean_map=zeros(10,10);
parameters.neighbour_sigma=0.1;
parameters.sensor_sigma=1;
parameters.time_sigma=0.000001;
parameters.error_tolerance=0.00001;
parameters.occupancyThreshold=2;
variance_map=zeros(10*10,10*10);
occupancy_map=ones(10,10);
occupancy_map(1,5)=3;
occupancy_map(2,5)=3;
occupancy_map(3,5)=3;
occupancy_map(4,5)=3;
occupancy_map(7,5)=3;
occupancy_map(7,6)=3;
occupancy_map(7,7)=3;
occupancy_map(7,8)=3;
occupancy_map(7,9)=3;
occupancy_map(7,10)=3;

reading=[33 35];
position=[1 3; 9 10];

[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);
K=mat2gray(mean_map);
imshow(K, 'InitialMagnification', 800);

reading=[33 32];
position=[1 3; 10 10];

[mean_map,variance_map]=randomField(mean_map,reading,position,parameters,variance_map,occupancy_map);

K=mat2gray(mean_map);
imshow(K, 'InitialMagnification', 800);

%% test the exploreMaxVariance

clear all;
dimension=[4 6];
variance_vector=randi([0 20],1,24);
variance_matrix= diag(variance_vector);
%%

variance_map=reshape(variance_vector,6,4)';
position=[4 6];

%%
goal=exploreMaxVariance(variance_matrix,0,position,dimension)

