function [mean_map, variance_map] = randomField(mean_map,reading,position,parameters,variance_map,occupancy_map )
%RANDOMFIELD Summary of this function goes here
%   Detailed explanation goes here
num_cells=numel(mean_map);
length_reading=length(reading);

% probability for obstacle or not obstacle
p_n_o=0.001;
p_o=1-p_n_o;

%if length_reading==1
 %   error('You should at least passing in two different sensor reading');
%end
[num_row_map,num_col_map]=size(mean_map);


if sum(variance_map(:))==0
    num_neighbour=(num_row_map-1)+(num_col_map-1)+(num_row_map-1)*(num_col_map-1)*2;

    num_row_J=num_neighbour+length_reading;  % one reading, if reading number changed, here need to change
    num_col_J=num_cells;

    % initial Jocabian matrix and variance matrix
    J=zeros(num_row_J, num_col_J);
    sigma=eye(num_row_J);
    
    r=1;
    % create the first Jocabian matrix and variance matrix
    if length_reading==1
        J(r,(position(1)-1)*num_col_map+position(2))=1;
        sigma(r,r)=1/parameters.sensor_sigma^2;
    else 
        for i=1:length_reading
            J(r,(position(i,1)-1)*num_col_map+position(i,2))=1;
            sigma(r,r)=1/parameters.sensor_sigma^2;
            r=r+1;
        end
    end
    
    for i=1:num_row_map
        for j=1:num_col_map
            if i-1>0
                if j-1>0  
                    J(r,(i-1)*num_col_map+j)=1;
                    J(r,(i-2)*num_col_map+j)=-1; 
                    if occupancy_map(i,j)>parameters.occupancyThreshold || occupancy_map(i-1,j)>parameters.occupancyThreshold
                        sigma(r,r)=(1-p_o)^2/parameters.neighbour_sigma^2;
                    else
                        sigma(r,r)=1/parameters.neighbour_sigma^2;
                    end
                    r=r+1;
                
                    J(r,(i-1)*num_col_map+j)=1;
                    J(r,(i-1)*num_col_map+j-1)=-1; 
                 
                    if occupancy_map(i,j)>parameters.occupancyThreshold || occupancy_map(i,j-1)>parameters.occupancyThreshold
                        sigma(r,r)=(1-p_o)^2/parameters.neighbour_sigma^2;
                    else
                        sigma(r,r)=1/parameters.neighbour_sigma^2;
                    end
                    r=r+1;
                    
                else 
                    J(r,(i-1)*num_col_map+j)=1;
                    J(r,(i-2)*num_col_map+j)=-1; 
                 
                    if occupancy_map(i,j)>parameters.occupancyThreshold || occupancy_map(i-1,j)>parameters.occupancyThreshold
                        sigma(r,r)=(1-p_o)^2/parameters.neighbour_sigma^2;
                    else
                        sigma(r,r)=1/parameters.neighbour_sigma^2;
                    end 
                    r=r+1;
                end    
            else
                if j-1>0
                    J(r,(i-1)*num_col_map+j)=1;
                    J(r,(i-1)*num_col_map+j-1)=-1;
                    if occupancy_map(i,j)>parameters.occupancyThreshold || occupancy_map(i,j-1)>parameters.occupancyThreshold
                        sigma(r,r)=(1-p_o)^2/parameters.neighbour_sigma^2;
                    else
                        sigma(r,r)=1/parameters.neighbour_sigma^2;
                    end
                    r=r+1;
                end   
            end
        end
    end

    % expect value of map
    mu=[reading zeros(1,num_neighbour)]';

else 
    % create the jacobian matrix 
    J=[zeros(length_reading,num_cells); eye(num_cells)];
    r=1;
    % create the first Jocabian matrix and variance matrix
    if length_reading==1
    J(r,(position(1)-1)*num_col_map+position(2))=1;
    else 
    for i=1:length_reading
        J(r,(position(i,1)-1)*num_col_map+position(i,2))=1;
        r=r+1;
    end
    end
    %create variance covariance matrix
    
    % first part from map distribution
    sigma_1=eye(length_reading)*parameters.sensor_sigma^2;
    
    % second part from reading
    sigma_2=variance_map+eye(num_cells)*(parameters.time_sigma^2);

    % combine two sigma
    sigma=inv(blkdiag(sigma_1,sigma_2));

    % create the expectation matrix
    tep_mean=mean_map';
    mu=[reading tep_mean(:)']';
end

m=repmat(mean(reading),1,num_cells)';

[mean_map,variance_map]=getMap(J,sigma,mu,m,parameters.error_tolerance);

%mean_map=vec2mat(mean_map,num_col_map);
mean_map=reshape(mean_map,num_col_map,num_row_map)';
end

