function [ H, delta_M, g] = solveDeltaM(J,sigma,mu,m)
%solve the linear regression J'*Var*J=-J'*Var(M-mu)
%  J: Jacobian matrix
%  Var: Variance covariance matrix
%  M: matrix of map
%  mu: expectation matrix for map
%  H=J'*Var*J : Hassien matrix
%  g=J'*Var*(M-mu) : gradient matrix

ini_M=J*m;
jvar=J'*sigma;
H=jvar*J;
g=-jvar*(ini_M-mu);
delta_M=H\g;

end

