#pragma once
#include "sensor_node.h"
#include <ros/ros.h>

#include <string>
#include <aqs_node/THD.h>
#include <boost/function.hpp>
#include <geometry_msgs/PoseStamped.h>

namespace thd_mapping {
    class BasicNode : public SensorNode {
    public:
        BasicNode();
        BasicNode(std::string);
        BasicNode(std::string,boost::function<void(const SensorNode&)>);
        BasicNode(std::string,Position);
        BasicNode(std::string,Position, boost::function<void(const SensorNode&)>);
        virtual std::string getName() const { return mName; }
        virtual Position getPosition() const;
        virtual Reading getReading() const;
        virtual void thdCallback(const aqs_node::THD::ConstPtr&);
        virtual void posCallback(const geometry_msgs::PoseStamped::ConstPtr&);
    protected:
        Reading mReading;
        Position mPosition;
        const std::string mName;
        ros::Subscriber mSubThd;
        ros::Subscriber mSubPos; 
        boost::function<void(const SensorNode&)> mCallback;
    };
}
