#pragma once

#include <thd_mapping/gdm_algorithm.h>
#include <cmath>

namespace thd_mapping {

class KernelDMVAlgorithm : public GDMAlgorithm
{

  GridMap vGrid;

  int mKernelSize;

  float kernelSigma;

  float scalingSigma;

  bool computeVarianceMap;

public:

  inline const GridMap& getMeanMap() const { return GDMAlgorithm::getMap(); }

  inline const GridMap& getVarianceMap() const { return vGrid; }

  virtual void addDataPoint(const DataPoint& dataPoint);

  virtual void addDataPoints(const std::vector<DataPoint>& dataPoints);

  KernelDMVAlgorithm(GridMap && m_grid,
                     GridMap && v_grid,
                     float kernel_sigma = 5.0,
                     float scaling_sigma = 1.0,
                     bool compute_variance_map = false);

  virtual ~KernelDMVAlgorithm();
};

}
