#include <thd_mapping/weighted_average_mapper.h>
#include <cassert>
#include <iostream>
#include "ros/ros.h"

namespace thd_mapping {

WeightedAverageMapper::WeightedAverageMapper(GridMap&& grid)
  : GDMAlgorithm(std::move(grid))
{}


void WeightedAverageMapper::addDataPoints(const std::vector<DataPoint>& dataPoints) //Relies on time points being syncroniced
{
  std::vector<DataPoint> timeStepPoints;
  for(size_t i = 0; i < dataPoints.size(); i++)
	{

		for (int64_t time = dataPoints[0].time; time == dataPoints[i].time; i++)
		{
			timeStepPoints.push_back(dataPoints[i]);
		}
        ROS_INFO("%d",(int)timeStepPoints.size());
		// std::cout << timeStepPoints.size() << "\n" << "test";

		glm::ivec2 xy; 
		for (xy.y = 0; xy.y < mGrid.dim.y; xy.y++)
		{
			for (xy.x = 0; xy.x < mGrid.dim.y; xy.x++)
			{
        size_t gridIndex = size_t(xy.x + xy.y * mGrid.dim.y);
				float sumDist = 0;

				for(auto& timePoint : timeStepPoints)
				{
					glm::vec2 gridPos = mGrid.toGridIndices(timePoint.position);
					sumDist += glm::length2(glm::vec2(xy) - mGrid.toGridIndices(timePoint.position));
				}
				float avgDist = sumDist / timeStepPoints.size();
				float gamma = 0.002;
				float contribution = 0;
				for(auto& timePoint : timeStepPoints)
				{
					float contributionFactor = glm::length2(glm::vec2(xy) - mGrid.toGridIndices(timePoint.position)) / sumDist;
          contribution += contributionFactor*timePoint.data;
					
				}
				float& gridValue = mGrid.grid[gridIndex];
					gridValue = gridValue * (1 - gamma) + contribution*gamma;
				
				
			}
		}
	}
}

void WeightedAverageMapper::addDataPoint(const DataPoint& dataPoint)
{
	assert(false && "Not Implemented");
}

}
