


init = function () {
    // Connect to ROS.
    var ros = new ROSLIB.Ros({
      url : 'ws://localhost:9090'
    });
    grids = [{
        grid: new MeasurementMapView({
            alpha: 1.0
        }),
        scale: new ScaleView({}),
        rosTopic: new ROSLIB.Topic({
            ros: ros,
            name: "/tempgridmap",
            messageType: 'thd_mapping/MeasurementMap',
            compression: 'png'
        })
    },
    {
        grid: new OccupancyGridView({
            alpha: 1.0
        }),
        rosTopic: new ROSLIB.Topic({
            ros: ros,
            name: "/map",
            messageType: 'nav_msgs/OccupancyGrid',
            compression: 'png'
        })
    }];

    sensors = [{
        sensor: new PoseStampedView({}),
        rosTopic: new ROSLIB.Topic({
            ros: ros,
            name: "/n5/pos",
            messageType: 'geometry_msgs/PoseStamped',
        })
    },{
        sensor: new PoseStampedView({}),
        rosTopic: new ROSLIB.Topic({
            ros: ros,
            name: "/n9/pos",
            messageType: 'geometry_msgs/PoseStamped',
        })
    },{
        sensor: new PoseStampedView({}),
        rosTopic: new ROSLIB.Topic({
            ros: ros,
            name: "/estimated",
            messageType: 'geometry_msgs/PoseStamped',
        })
    }];



    // Setup the map client.
    var gridClient = new Renderer({
      ros : ros,
      canvasId : "canvas1",
      scale: 2.0,
      sensors: sensors,
      grids: grids
    });

    var gridClient = new Renderer({
      ros : ros,
      canvasId : "canvas2",
      scale: 2.0,
      sensors: sensors,
      grids: grids
    });
};
