#!/bin/env python
import sqlite3
import numbers
import rospy
import argparse

parser = argparse.ArgumentParser("Read the data")
parser.add_argument('--input')
parser.add_argument('--output')
parser.parse_args()

dbName = "sens.db"
if parser.input:
  dbName = parser.input

outputName = "cleanData.txt"
if parser.output:
  outputName = parser.output
  
#Variables 
first = True
bot = 0

# Open DB
print("Opening DB -- ", dbName)
conn =  sqlite3.connect(dbName)
c = conn.cursor()

#Check data quality
query = '''SELECT time FROM measurement GROUP BY time HAVING count(time) = 3;'''
c.execute(query)
data = c.fetchall()
print("Total number of good data-points: ", len(data))

print("Beginning write to file:", outputName)
with open(outputName, "w") as file:
  for row in data:
    if first:
      bot = row[0]
      first = False
    dat = str(rospy.Time(row[0]))
    query = '''
SELECT temp, humidity, occlusion, name 
FROM measurement 
INNER JOIN node ON node.ID = measurement.node_id 
WHERE time LIKE ?'''
    c.execute(query, ((row[0]),))
    for result in c.fetchall():
      for  elem in result:
        if isinstance(elem, numbers.Number):
          elem = round(elem, 1)
        dat = dat + ", " + str(elem)
#    print(dat,end="\n")
    file.write(dat + "\n")
print("Finished writing to file")
